from rocolib.api.components.Component import Component

c = Component()

c.addParameter("width", 90, paramType="length")
c.addParameter("depth", 70, paramType="length")
# c.addConstraint(("boat", "boat.width"), "width")
# c.addConstraint(("boat", "boat.depth"), "depth")

c.addSubcomponent("lServoMount", "SideServoMount", inherit=("depth","length"))
c.inheritAllInterfaces("lServoMount")
c.addSubcomponent("rServoMount", "SideServoMount", inherit=("depth","length"))
c.inheritAllInterfaces("rServoMount")
#Bottom belt
c.addSubcomponent("lservodown", "Rectangle")
c.addConstraint(("lservodown", "w"), "lServoMount.depth")
c.addConstraint(("lservodown", "l"), (("depth"), "lServoMount.length"), "x[0] - x[1]") #DEPTH OF BOAT - 3 for the tab

c.addSubcomponent("lservoacross", "Rectangle")
c.addConstraint(("lservoacross", "w"), "lServoMount.depth")
c.addConstraint(("lservoacross", "l"), ("width"), "x * 0.5") #DEPTH OF BOAT - 3 for the tab

c.addConnection(("lservodown", "r"),("lservoacross", "r"), angle=-90)
c.addConnection(("lservodown", "l"), ("lServoMount", "leftInterface"))

c.addSubcomponent("rservodown", "Rectangle")
c.addConstraint(("rservodown", "w"), "rServoMount.depth")
c.addConstraint(("rservodown", "l"), (("depth"), "rServoMount.length"), "x[0] - x[1]") #DEPTH OF BOAT - 3 for the tab

c.addSubcomponent("rservoacross", "Rectangle")
c.addConstraint(("rservoacross", "w"), "rServoMount.depth")
c.addConstraint(("rservoacross", "l"), ("width"), "x * 0.5") #DEPTH OF BOAT - 3 for the tab

c.addConnection(("rservodown", "r"),("rservoacross", "r"), angle=-90)
c.addConnection(("rservodown", "l"), ("rServoMount", "rightInterface"))

c.addConnection(("lservoacross", "l"), ("rservoacross", "l"), tabWidth=5)

c.inheritInterface("lServoInterface", ("lServoMount", "rightInterface"))
c.inheritInterface("rServoInterface", ("rServoMount", "leftInterface"))

#
c.toLibrary("DoubleServoMount")
